VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cfMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public WithEvents Form As cWidgetForm, WithEvents Page As cWidgetForm
Attribute Form.VB_VarHelpID = -1
Attribute Page.VB_VarHelpID = -1
Public PageWidthInch As Double, PageHeightInch As Double
Public WithEvents BtnLoad As cwButton, WithEvents BtnSave As cwButton
Attribute BtnLoad.VB_VarHelpID = -1
Attribute BtnSave.VB_VarHelpID = -1

Private Sub BtnLoad_Click()
    Dim sFile As String:            Dim sXML As String
    'Dim oWidgetLoader As IWidgetLoader
    
    'Set oWidgetLoader = New IWidgetLoader
                            
    sFile = App.Path & "\Page1.xml"
    
    If New_c.FSO.FileExists(sFile) = True Then
        sXML = New_c.FSO.ReadTextContent(sFile)
        Page.Widgets.RemoveAll
        'Page.Widgets.LoadFromXML sXML, oWidgetLoader.CreateWidget("cwShape")
        Page.Widgets.LoadFromXML sXML
        Page.Refresh
    End If
    
End Sub

Private Sub BtnSave_Click()
    Dim sFile As String:            Dim sXML As String
            
    sFile = App.Path & "\Page1.xml"
    
    sXML = Page.Widgets.SerializeToXML()
    New_c.FSO.WriteTextContent App.Path & "\Page1.xml", sXML
    
End Sub

Private Sub Class_Initialize()
  Set Form = Cairo.WidgetForms.Create(vbSizable, "Shape-Handling at constant 96dpi (Page=8.5x11 inch)", True, 1024, 768)
      Form.SetMinMaxDimensions 720, 560
      Form.IconImageKey = "frmIco" 'ensure a Form-Icon per ImageList-Key (Icon was loaded in Sub Main)
      Form.WidgetRoot.BackColor = &H888888
  
  PageWidthInch = 8.5:          PageHeightInch = 11 'let's define an absolute Page-Size
  
  Set Page = Cairo.WidgetForms.CreateChild(Form.hWnd)
      Page.WidgetRoot.BackColor = vbWhite
      Page.WidgetRoot.DesignMode = True
      Page.WidgetRoot.DesignModeGridWidth = 4
End Sub

Private Sub Form_Load() 'shape-coords are absolute inches
    AddNewShape "S1", 0.5, 0.5, 2, 1
    AddNewShape "S2", 2, 2, 2, 1
    AddNewShape "S3", 3.5, 3.5, 2, 1
        
    AddNewTextBox "T1", 0.5, 5, 2, 1
    AddNewTextBox "T2", 2, 6.5, 2, 1
    AddNewTextBox "T3", 3.5, 8, 2, 1
    
    Set BtnSave = Form.Widgets.Add(New cwButton, "BtnSave", 16, 8, 160, 24)
        BtnSave.Caption = "Save to XML"
    Set BtnLoad = Form.Widgets.Add(New cwButton, "BtnLoad", 16, 40, 160, 24)
        BtnLoad.Caption = "Load From XML"
        
End Sub

Private Sub Form_ResizeWithDimensions(ByVal NewWidth As Long, ByVal NewHeight As Long)
    Dim x, y, dx, dy
    Cairo.CalcAspectFit PageWidthInch / PageHeightInch, NewWidth, NewHeight, x, y, dx, dy, 20
    Page.Move x, y, dx, dy
End Sub

Private Sub Form_DblClick() 'double-clicking the (dark-gray) Form-area will write the Page as a PDF-File into the App-Path
    Dim sFile As String:            Dim sXML As String
    
    sFile = App.Path & "\Page1.xml"
    
    With New_c.FSO
        If .FileExists(sFile) = True And Page.Widgets.Count = 0 Then
            DoLoadFromXML sFile
        Else
            DoSerializeToXML sFile
        End If
    End With
    
End Sub

Private Sub Page_ResizeWithDimensions(ByVal NewWidth As Long, ByVal NewHeight As Long)
    Page.WidgetRoot.Zoom = NewWidth / (PageWidthInch * 96)
End Sub

Private Sub AddNewShape(Name As String, x, y, dx, dy)  'coords in inches
    Dim Shape As cwShape
    
    Set Shape = Page.Widgets.Add(New cwShape, Name, x * 96, y * 96, dx * 96, dy * 96)
    
End Sub

Private Sub AddNewTextBox(Name As String, x, y, dx, dy)  'coords in inches
    Dim Shape As cwTextBox
    
    Set Shape = Page.Widgets.Add(New cwTextBox, Name, x * 96, y * 96, dx * 96, dy * 96)
    
End Sub

